﻿# Diffusion .NET Client Library Changes

## Version 6.1.7

Bugs fixed:

* A connection is now fully closed when detecting possible inactivity.


## Version 6.1.6

Bugs fixed:

* A topic selector containing the '|' character is now parsed correctly.


## Version 6.1.5

Changes:

* Improved memory profile during connection loss.

Bugs fixed:

* A websocket connection/reconnection can no longer become stuck in a infinite loop.
* Automatic reconnection does no longer use threads from the threadpool for each reconnection attempt.
* Automatic reconnection no longer keeps threads stuck in a waiting state during the reconnection phase.
* Closing a session during reconnection now correctly prevents any further reconnection attempts.
* A asynchronous request to the Diffusion server with a canceled `CancellationToken` no longer sends the request to the server before completing the `Task` in a canceled state.


## Version 6.1.4

Bugs fixed:

* `PushTechnology.ClientInterface.Client.Session.ISession.Attributes{get}->ISessionAttributes` now correctly returns a `PushTechnology.ClientInterface.Client.Session.ISessionAttributes` instance.


## Version 6.1.2

Changes:

* The default SSLContext no longer allows all connections by default. You can specify your own SSLContext verification callback via `PushTechnology.ClientInterface.Client.Session.ISessionFactory.SslContext(RemoteCertificateValidationCallback)->ISessionFactory` in case this behavior is required for testing purposes.
* Removed direct `Microsoft.CSharp` dependency.
* `PushTechnology.ClientInterface.Client.Content.IRecordBuilder.Add()` now expects `ICollection<object>` instead of `ICollection<dynamic>` as fields.
* `PushTechnology.ClientInterface.Client.Content.IRecordFactory.NewRecord()` now expects `ICollection<object>` instead of `ICollection<dynamic>` as fields.
* `PushTechnology.ClientInterface.Client.Content.IRecordContentBuilder.PutFields()` now expects `ICollection<object>` instead of `ICollection<dynamic>` as fields.
* `PushTechnology.ClientInterface.Client.Content.Metadata.IRecordStructuredBuilder.Set()` now expects `ICollection<object>` instead of `ICollection<dynamic>` for values.
* `PushTechnology.ClientInterface.Client.Content.Metadata.IRecordStructuredBuilder.Add()` now expects `ICollection<object>` instead of `ICollection<dynamic>` for values.

Bugs fixed:

* JSON strings containing escaped reverse solidus characters at the end will no longer throw `InvalidDataException`.


## Version 6.1.1

Bugs fixed:

* Fragmented handshake packets are now properly handled on session connection. Previously a session connection would time out if it encountered a fragmented packet.
* Establishing a session using an HTTP proxy would fail with various different error messages. This has now been corrected.


## Version 6.1.0

Highlights:

* New .NET Standard 2.0 compatible library (`Diffusion.Client.dll`).
* New NuGet package <https://www.nuget.org/packages/Diffusion.Client>.
* Support for TimeSeries topics.
* Support for topic notifications.
* Support of the new REMOVAL topic specification.
* Support for request and response messaging.
* Includes bugfixes up to Version 6.0.4.

Changes:

* The `PushTechnology.ClientInterface.dll` library has now been removed in favor of the .NET Standard 2.0 compatible `Diffusion.Client` library.
* Unused `PushTechnology.ClientInterface.Client.Features.Control.Topics.IRequestHandler` was replaced with a new one needed for Request/Response messaging.
* `PushTechnology.ClientInterface.Client.Content.Update.ContentUpdateAction` is now a simple `enum` instead of a `class`.
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.TopicAddFailReason` is now a simple `enum` instead of a `class`.
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IClientControl.SessionIdFromString(string)->SessionId` changed to `PushTechnology.ClientInterface.Client.Features.Control.Client.IClientControl.SessionIdFromString(string)->ISessionId`.
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IQueueEventHandler.OnLowerThresholdCrossed(SessionId,IMessageQueuePolicy)->void` changed to `PushTechnology.ClientInterface.Client.Features.Control.Clients.IQueueEventHandler.OnLowerThresholdCrossed(ISessionId,IMessageQueuePolicy)->void`.
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IQueueEventHandler.OnUpperThresholdCrossed(SessionId,IMessageQueuePolicy)->void` changed to `PushTechnology.ClientInterface.Client.Features.Control.Clients.IQueueEventHandler.OnUpperThresholdCrossed(ISessionId,IMessageQueuePolicy)->void`.
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISessionPropertiesContextCallback<TC>.OnReply(TC,SessionId,Dictionary<string,string>)->void` changed to `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISessionPropertiesContextCallback<TC>.OnReply(TC,ISessionId,Dictionary<string,string>)->void`.
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISessionPropertiesContextCallback<TC>.OnUnknownSession(TC,SessionId)->void` changed to `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISessionPropertiesContextCallback<TC>.OnUnknownSession(TC,ISessionId)->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISessionPropertiesListener.OnSessionClose(SessionId,IDictionary<string,string>,CloseReason)->void` changed to `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISessionPropertiesListener.OnSessionClose(ISessionId,IDictionary<string,string>,CloseReason)->void`.
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISessionPropertiesListener.OnSessionEvent(SessionId,SessionPropertiesListenerEventType?,IDictionary<string,string>,IDictionary<string,string>)->void` changed to `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISessionPropertiesListener.OnSessionEvent(ISessionId,SessionPropertiesListenerEventType?,IDictionary<string,string>,IDictionary<string,string>)->void`.
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISessionPropertiesListener.OnSessionOpen(SessionId,IDictionary<string,string>)->void` changed to `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISessionPropertiesListener.OnSessionOpen(ISessionId,IDictionary<string,string>)->void`.
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.QueueEventHandlerDefault.OnLowerThresholdCrossed(SessionId,IMessageQueuePolicy)->void` changed to `PushTechnology.ClientInterface.Client.Features.Control.Clients.QueueEventHandlerDefault.OnLowerThresholdCrossed(ISessionId,IMessageQueuePolicy)->void`.
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.QueueEventHandlerDefault.OnUpperThresholdCrossed(SessionId,IMessageQueuePolicy)->void` changed to `PushTechnology.ClientInterface.Client.Features.Control.Clients.QueueEventHandlerDefault.OnUpperThresholdCrossed(ISessionId,IMessageQueuePolicy)->void`.
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.SessionPropertiesListenerDefault.OnSessionClose(SessionId,IDictionary<string,string>,CloseReason)->void` changed to `PushTechnology.ClientInterface.Client.Features.Control.Clients.SessionPropertiesListenerDefault.OnSessionClose(ISessionId,IDictionary<string,string>,CloseReason)->void`.
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.SessionPropertiesListenerDefault.OnSessionEvent(SessionId,SessionPropertiesListenerEventType?,IDictionary<string,string>,IDictionary<string,string>)->void` changed to `PushTechnology.ClientInterface.Client.Features.Control.Clients.SessionPropertiesListenerDefault.OnSessionEvent(ISessionId,SessionPropertiesListenerEventType?,IDictionary<string,string>,IDictionary<string,string>)->void`.
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.SessionPropertiesListenerDefault.OnSessionOpen(SessionId,IDictionary<string,string>)->void` changed to `PushTechnology.ClientInterface.Client.Features.Control.Clients.SessionPropertiesListenerDefault.OnSessionOpen(ISessionId,IDictionary<string,string>)->void`.
* `PushTechnology.ClientInterface.Client.Features.Control.ISessionPropertiesCallback.OnReply(SessionId,Dictionary<string,string>)->void` changed to `PushTechnology.ClientInterface.Client.Features.Control.ISessionPropertiesCallback.OnReply(ISessionId,Dictionary<string,string>)->void`.
* `PushTechnology.ClientInterface.Client.Features.Control.ISessionPropertiesCallback.OnUnknownSession(SessionId)->void` changed to `PushTechnology.ClientInterface.Client.Features.Control.ISessionPropertiesCallback.OnUnknownSession(ISessionId)->void`.
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IFetchRequest.Client->SessionId{get}->SessionId` now returns `ISessionId` instead.
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IMessageHandler.OnMessage(SessionId,string,IContent,IReceiveContext)->void` changed to `PushTechnology.ClientInterface.Client.Features.Control.Topics.IMessageHandler.OnMessage(ISessionId,string,IContent,IReceiveContext)->void`.
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IMissingTopicNotification.SessionId{get}->SessionId` now returns `ISessionId` instead.
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IRoutingSubscriptionRequest.SessionId{get}->SessionId` now returns `ISessionId` instead.
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionCallback.OnComplete(SessionId,string)->void` changed to `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionCallback.OnComplete(ISessionId,string)->void`.
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionContextCallback<in TC>.OnComplete(TC,SessionId, string)->void` changed to `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionContextCallback<in TC>.OnComplete(TC,ISessionId, string)->void`.
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.MessageReceiverDefault.OnMessage(SessionId,string,IContent,IReceiveContext)->void` changed to `PushTechnology.ClientInterface.Client.Features.Control.Topics.MessageReceiverDefault.OnMessage(ISessionId,string,IContent,IReceiveContext)->void`.
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.SubscriptionCallbackDefault.OnComplete(SessionId,string)->void` changed to `PushTechnology.ClientInterface.Client.Features.Control.Topics.SubscriptionCallbackDefault.OnComplete(ISessionId,string)->void`.
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.SubscriptionContextCallbackDefault<TC>.OnComplete(TC,SessionId,string)->void` changed to `PushTechnology.ClientInterface.Client.Features.Control.Topics.SubscriptionContextCallbackDefault<TC>.OnComplete(TC,ISessionId,string )->void`.
* `PushTechnology.ClientInterface.Client.Session.ISession.SessionId->SessionId{get}->SessionId` now returns `ISessionId` instead.
* `PushTechnology.ClientInterface.Client.Topics.TopicType` is now a simple `enum` instead of a `class`.
* All methods within `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISubscriptionControl` that take a `PushTechnology.ClientInterface.Client.Topics.ITopicSelector` as an argument will throw a `ArgumentException` if the provided topic selector is a custom implementation instead of one created by the API.
* `PushTechnology.ClientInterface.Data.DataTypeNames.BINARY` is now `const string` instead of `static readonly string`.
* `PushTechnology.ClientInterface.Data.DataTypeNames.JSON` is now `const string` instead of `static readonly string`.
* `PushTechnology.ClientInterface.Data.DataTypeNames.DOUBLE` is now `const string` instead of `static readonly string`.
* `PushTechnology.ClientInterface.Data.DataTypeNames.INT64` is now `const string` instead of `static readonly string`.
* `PushTechnology.ClientInterface.Data.DataTypeNames.STRING` is now `const string` instead of `static readonly string`.
* `PushTechnology.ClientInterface.Data.DataTypeNames.RECORD_V2` is now `const string` instead of `static readonly string`.

Types added:

* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IFilteredRequestCallback<TResponse>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IRequestContext`
* `PushTechnology.ClientInterface.Client.Features.IRequestStream<TRequest, TResponse>`
* `PushTechnology.ClientInterface.Client.Features.IResponder<TResponse>`
* `PushTechnology.ClientInterface.Client.Features.TimeSeries.ITimeSeries`
* `PushTechnology.ClientInterface.Client.Features.TimeSeries.IEventMetadata`
* `PushTechnology.ClientInterface.Client.Features.TimeSeries.IEvent<TValue>`
* `PushTechnology.ClientInterface.Client.Features.TimeSeries.StreamStructure`
* `PushTechnology.ClientInterface.Client.Features.TimeSeries.IQueryResult<TValue>`
* `PushTechnology.ClientInterface.Client.Features.TimeSeries.IQuery<TValue>`
* `PushTechnology.ClientInterface.Client.Features.TimeSeries.IRangeQuery<TValue>`
* `PushTechnology.ClientInterface.Client.Features.TimeSeries.InvalidQueryException`
* `PushTechnology.ClientInterface.Client.Features.TimeSeries.NoSuchEventException`
* `PushTechnology.DiffusionCore.Exceptions.InvalidFilterException`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicNotifications`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.INotificationRegistration`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.NotificationType`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicNotificationListener`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.TopicNotificationListenerDefault`

Methods added:

* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IClientControl.SetSessionPropertiesAsync(ISessionId,Dictionary<string,string>)->Task<IReadOnlyDictionary<string,string>>`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IClientControl.SetSessionPropertiesAsync(ISessionId,Dictionary<string,string>,CancellationToken)->Task<IReadOnlyDictionary<string,string>>`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IClientControl.SetSessionPropertiesAsync(string,Dictionary<string,string>)->Task<object>`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IClientControl.SetSessionPropertiesAsync(string,Dictionary<string,string>,CancellationToken)->Task<object>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IMessagingControl.AddRequestHandler<TRequest, TResponse>(string,IRequestHandler<TRequest, TResponse>,params string[])->Task<IRegistration>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IMessagingControl.SendRequestAsync<TRequest,TResponse>(ISessionId,string,TRequest)->Task<TResponse>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IMessagingControl.SendRequestAsync<TRequest,TResponse>(ISessionId,string,TRequest,CancellationToken)->Task<TResponse>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IMessagingControl.SendRequestToFilterAsync<TRequest,TResponse>(string,string,TRequest,IFilteredRequestCallback<TResponse>)->Task<int>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IMessagingControl.SendRequestToFilterAsync<TRequest,TResponse>(string,string,TRequest,IFilteredRequestCallback<TResponse>,CancellationToken)->Task<int>`
* `PushTechnology.ClientInterface.Client.Features.ITopics.AddTimeSeriesStream<TValue>(ITopicSelector,IValueStream<IEvent<TValue>>)->void`
* `PushTechnology.ClientInterface.Client.Features.ITopics.AddTimeSeriesStream<TValue>(string,IValueStream<IEvent<TValue>>)->void`
* `PushTechnology.ClientInterface.Client.Features.IMessaging.RemoveRequestStream(string)->Callbacks.IStream`
* `PushTechnology.ClientInterface.Client.Features.IMessaging.SendRequestAsync<TRequest,TResponse>(string,TRequest)->Task<TResponse>`
* `PushTechnology.ClientInterface.Client.Features.IMessaging.SendRequestAsync<TRequest,TResponse>(string,TRequest,CancellationToken)->Task<TResponse>`
* `PushTechnology.ClientInterface.Client.Features.IMessaging.SetRequestStream<TRequest, TResponse>(string,IRequestStream<TRequest, TResponse>)->Callbacks.IStream`
* `PushTechnology.ClientInterface.Client.Session.ISession.TimeSeries{get}->ITimeSeries`
* `PushTechnology.ClientInterface.Client.Session.ISession.TopicNotifications{get}->ITopicNotifications`
* `PushTechnology.ClientInterface.Client.Callbacks.IRegistration.CloseAsync()->Task<object>`
* `PushTechnology.ClientInterface.Client.Features.IRegisteredHandler.CloseAsync()->Task<object>`

Fields added:

* `PushTechnology.ClientInterface.Client.Features.Control.Topics.TopicAddFailReason.EXCEEDED_LICENSE_LIMIT`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.TopicAddFailReason.INCOMPATIBLE_PARENT`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.TopicAddFailReason.INCOMPATIBLE_MASTER`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.TopicAddFailReason.EXISTS_INCOMPATIBLE`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.AddTopicResult.CREATED`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.AddTopicResult.EXISTS`
* `PushTechnology.ClientInterface.Client.Topics.Details.TopicSpecificationProperty.TimeSeriesEventValueType`
* `PushTechnology.ClientInterface.Client.Topics.Details.TopicSpecificationProperty.TimeSeriesRetainedRange`
* `PushTechnology.ClientInterface.Client.Topics.Details.TopicSpecificationProperty.TimeSeriesSubscriptionRange`
* `PushTechnology.ClientInterface.Client.Topics.Details.TopicSpecificationProperty.Persistent`
* `PushTechnology.ClientInterface.Client.Topics.Details.TopicSpecificationProperty.Removal`
* `PushTechnology.ClientInterface.Client.Topics.Details.TopicSpecificationProperty.Conflation`
* `PushTechnology.ClientInterface.Client.Topics.Details.TopicSpecificationProperty.Owner`
* `PushTechnology.ClientInterface.Client.Features.TopicUnsubscribeReason.UNKNOWN`
* `PushTechnology.ClientInterface.Client.Features.TopicUnsubscribeReason.BACK_PRESSURE`
* `PushTechnology.ClientInterface.Client.Topics.TopicType.TIME_SERIES`
* `PushTechnology.ClientInterface.Client.Topics.TopicType.UNKNOWN`

Types removed:

* `PushTechnology.ClientInterface.Client.Callbacks.DefaultStreamCallback`
* `PushTechnology.ClientInterface.Client.Callbacks.StreamDefault`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IAuthControlFeatureHandler`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IClientControlFeatureHandler`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IClientInfo`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IClientSession`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IQueueListener`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IStateListener`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IStatelessSubscriptionRequest`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IStatelessSubscriptionRequestHandler`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionRequest`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicManagementHandler`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicManagementFactory`
* `PushTechnology.ClientInterface.Client.Session.SessionId`
* `PushTechnology.ClientInterface.Client.Features.ITopicNotifications`

Methods removed:

* `PushTechnology.ClientInterface.Client.Session.ISession.GetAuthenticationControlFeature()->IAuthenticationControl`
* `PushTechnology.ClientInterface.Client.Session.ISession.GetClientControlFeature()->IClientControl`
* `PushTechnology.ClientInterface.Client.Session.ISession.GetMessagingControlFeature()->IMessagingControl`
* `PushTechnology.ClientInterface.Client.Session.ISession.GetMessagingFeature()->IMessaging`
* `PushTechnology.ClientInterface.Client.Session.ISession.GetPingFeature()->IPings`
* `PushTechnology.ClientInterface.Client.Session.ISession.GetSecurityControlFeature()->ISecurityControl`
* `PushTechnology.ClientInterface.Client.Session.ISession.GetSecurityFeature()->ISecurity`
* `PushTechnology.ClientInterface.Client.Session.ISession.GetSubscriptionControlFeature()->ISubscriptionControl`
* `PushTechnology.ClientInterface.Client.Session.ISession.GetSystemAuthenticationFeature()->ISystemAuthenticationControl`
* `PushTechnology.ClientInterface.Client.Session.ISession.GetTopicControlFeature()->ITopicControl`
* `PushTechnology.ClientInterface.Client.Session.ISession.GetTopicsFeature()->ITopics`
* `PushTechnology.ClientInterface.Client.Session.ISession.GetTopicUpdateControlFeature()->ITopicUpdateControl`

Fields removed:

* `PushTechnology.ClientInterface.Client.Features.IPingDetails.RoundTripTime->double`

Marked obsolete:

* `PushTechnology.ClientInterface.Client.Content.IContentBuilder`
* `PushTechnology.ClientInterface.Client.Content.IContentFactory`
* `PushTechnology.ClientInterface.Client.Content.IContentReader`
* `PushTechnology.ClientInterface.Client.Content.ISimpleContentBuilder`
* `PushTechnology.ClientInterface.Client.Content.Update.IUpdate`
* `PushTechnology.ClientInterface.Client.Factories.Diffusion.Content->IContentFactory`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.AddTopicResult.Created`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.AddTopicResult.Exists`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.TopicAddFailReason.INITIALISE_ERROR`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.TopicAddFailReason.TOPIC_NOT_FOUND`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.RemoveTopicsWithSession(string, Callbacks.ITopicTreeHandler)->void`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.RemoveTopicsWithSessionAsync(string)->Task<IRegistration>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.RemoveTopicsWithSessionAsync(string,CancellationToken)->Task<IRegistration>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IFetchRequest`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IFetchResponder`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.AddTopicEventListenerAsync(string,ITopicEventStream)->Task<IRegistration>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.AddTopicEventListenerAsync(string,ITopicEventStream,CancellationToken)->Task<IRegistration>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.AddTopicEventListener(string,ITopicControlTopicEventListener)->voITopicEventStreamid`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControlTopicEventListener`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicEventStream`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.TopicControlTopicEventListenerDefault`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.TopicEventStreamDefault`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.TopicControlEventListenerDefault`
* `PushTechnology.ClientInterface.Client.Features.ITopics.GetTopicDetails(string,TopicDetailsLevel,ITopicDetailsCallback)->void`
* `PushTechnology.ClientInterface.Client.Features.ITopics.GetTopicDetails(string,TopicDetailsLevel,IContext,ITopicDetailsCallback)->void`
* `PushTechnology.ClientInterface.Client.Features.ITopics.ITopicDetailsCallbackDefault`
* `PushTechnology.ClientInterface.Client.Features.ITopics.ITopicDetailsContextCallbackDefault<TContext>`
* `PushTechnology.ClientInterface.Client.Features.ITopics.TopicDetailsCallbackDefault`
* `PushTechnology.ClientInterface.Client.Features.ITopics.TopicDetailsContextCallbackDefault<TContext>`
* `PushTechnology.ClientInterface.Client.Session.IFetchResponseRegistration`
* `PushTechnology.ClientInterface.Client.Session.ISessionFactory.SslContext(RemoteCertificateValidationCallback,LocalCertificateSelectionCallback)->ISessionFactory`
* `PushTechnology.ClientInterface.Client.Types.IClientEndpoint`
* `PushTechnology.ClientInterface.Client.Callbacks.IRegistration.Close()->Task<object>`
* `PushTechnology.ClientInterface.Client.Features.IRegisteredHandler.Close()->Task<object>`

Known Issues:

* None

Notes:

Our .NET Standard 2.0 compatible client library (`Diffusion.Client`) is now out of beta and is replacing the old `PushTechnology.ClientInterface` library. The default namespace however is still `PushTechnology.ClientInterface`. As much as I would have liked to rename all namespaces to `Diffusion.Client` (for consistency reasons) I didn't want to burden our users with rewriting all `using` directives. `Diffusion.Client` is now officially tested and supported on Windows (via .NET Framework and/or .NET Core), MacOS (.NET Core), and Linux (.NET Core). Other runtimes such as Mono or Xamarin haven't been included in our automated testing yet. We do however have plans to officially support those platforms in future.
-DD


## Version 6.0.9

Changes:

* Improved memory profile during connection loss.

Bugs fixed:

* `PushTechnology.ClientInterface.Client.Session.ISession.Attributes{get}->ISessionAttributes` now correctly returns a `PushTechnology.ClientInterface.Client.Session.ISessionAttributes` instance.
* A websocket connection/reconnection can no longer become stuck in a infinite loop.
* A asynchronous request to the Diffusion server with a canceled `CancellationToken` no longer sends the request to the server before completing the `Task` in a canceled state.


## Version 6.0.8

Changes:

* The default SSLContext no longer allows all connections by default. You can specify your own SSLContext verification callback via `PushTechnology.ClientInterface.Client.Session.ISessionFactory.SslContext(RemoteCertificateValidationCallback)->ISessionFactory` in case this behavior is required for testing purposes.

Bugs fixed:

* JSON strings containing escaped reverse solidus characters at the end will no longer throw `InvalidDataException`.


## Version 6.0.5

Bugs fixed:

* Fragmented handshake packets are now properly handled on session connection. Previously a session connection would time out if it encountered a fragmented packet.
* Establishing a session using an HTTP proxy would fail with various different error messages. This has now been corrected.


## Version 6.0.4

Bugs fixed:

* When a Session connected with no password, this was wrongly encoded as `PushTechnology.DiffusionCore.Client.Types.CredentialsType.PLAIN_PASSWORD`. It is now encoded as `PushTechnology.DiffusionCore.Client.Types.CredentialsType.NONE`.
* `PushTechnology.ClientInterface.Data.JSON.IJSON.ToJSONString()->string` no longer returns invalid JSON.
* `PushTechnology.ClientInterface.Client.Session.ISessionOpenCallback` methods would be called more than once during a session lifetime. This has now been fixed.
* `PushTechnology.ClientInterface.Client.Session.ISessionOpenContextCallback<TC>` methods would be called more than once during a session lifetime. This has now been fixed.
* Fixed incorrect encoding of the URI which is now compliant with the generic URI syntax (RFC 3986).


## Version 6.0.3

Bugs fixed:

* The `IRecordV2.Diff` method did not indicate new fields added to the first record when the original data contained just a single empty record.


## Version 6.0.0

Highlights:

* New .NET Standard 2.0 compatible library called `Diffusion.Client.dll` (beta).
* RecordV2 topics and data types (replacement for the deprecated record topic type).
* Primitive topics and data types (Int64, Double, String).
* New async methods for `ITopics`, `ITopicControl`, and `IPings`.
* Reliable reconnection.
* Various performance improvements.
* A small JSON parser that reads JSON formatted strings. See: `PushTechnology.ClientInterface.IO.JSON.JSONReader`.
* Removal of various topic types such as: `PROTOCOL_BUFFER`, `SERVICE`, `PAGED_STRING`, and`PAGED_RECORD`.
* Removal of the classic client API.

Changes:

* Added a .NET Standard 2.0 compatible library called `Diffusion.Client.dll`. It is currently in beta.
* Upgraded `NLog` dependency from version `4.2.0` to `4.4.12`.
* Reconnection failure now reports CLOSE_FAILED instead of CLOSED_BY_SERVER.
* Features returned by `PushTechnology.ClientInterface.Client.Session.ISession` won't throw a `SessionClosedException` anymore. Except methods that return a `Task` or `Task<T>`. The returned task can still complete with a `SessionClosedException` exception.
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.CreateDetailsBuilder()` now works for `IUniversalTopicDetailsBuilder`.
* `PushTechnology.ClientInterface.Client.Callbacks.DefaultCallback` is no longer abstract.
* `PushTechnology.ClientInterface.Client.Callbacks.DefaultContextCallback<TContext>` is no longer abstract.
* `PushTechnology.ClientInterface.Client.Callbacks.IRegistration.Close()->void` changed to `PushTechnology.ClientInterface.Client.Callbacks.IRegistration.Close()->Task<object>`.
* `PushTechnology.ClientInterface.Client.Features.CallbackDefault` is no longer abstract.
* `PushTechnology.ClientInterface.Client.Features.ContextCallbackDefault<TContext>` is no longer abstract.
* `PushTechnology.ClientInterface.Client.Features.StreamDefault` is no longer abstract.
* `PushTechnology.ClientInterface.Client.Features.ContextStreamDefault<TContext>` is no longer abstract.
* `PushTechnology.ClientInterface.Client.Features.TopicTreeHandlerDefault` is no longer abstract.
* `PushTechnology.ClientInterface.Client.Features.IRegisteredHandler.Close()->void` changed to `PushTechnology.ClientInterface.Client.Features.IRegisteredHandler.Close()->Task<object>`.
* `PushTechnology.ClientInterface.Client.Session.SessionClosedException` now inherits from the newly added `PushTechnology.ClientInterface.Client.Session.SessionException`.
* `PushTechnology.DiffusionCore.Buffering.ByteBuffer` is no longer marked `Serializable`.
* `PushTechnology.ClientInterface.IO.CBOR.CBORReader.GetBytes()->byte[]` now returns the internal value instead of a copy.

Types added:

* `PushTechnology.ClientInterface.Data.DataTypeNames`
* `PushTechnology.ClientInterface.Data.Record.IRecordV2`
* `PushTechnology.ClientInterface.Data.Record.IRecordV2Builder`
* `PushTechnology.ClientInterface.Data.Record.ChangeType`
* `PushTechnology.ClientInterface.Data.Record.IChange`
* `PushTechnology.ClientInterface.Data.Record.IRecordV2Delta`
* `PushTechnology.ClientInterface.Data.Record.IRecordV2DataType`
* `PushTechnology.ClientInterface.Data.Record.Schema.INode`
* `PushTechnology.ClientInterface.Data.Record.Schema.FieldType`
* `PushTechnology.ClientInterface.Data.Record.Schema.IField`
* `PushTechnology.ClientInterface.Data.Record.Schema.IRecord`
* `PushTechnology.ClientInterface.Data.Record.Schema.ISchema`
* `PushTechnology.ClientInterface.Data.Record.Schema.ISchemaBuilder`
* `PushTechnology.ClientInterface.Data.Record.Schema.SchemaParseException`
* `PushTechnology.ClientInterface.Data.Record.Schema.SchemaViolationException`
* `PushTechnology.ClientInterface.Data.Record.Model.IRecordModel`
* `PushTechnology.ClientInterface.Data.Record.Model.IMutableRecordModel`
* `PushTechnology.ClientInterface.Services.ServiceException`
* `PushTechnology.ClientInterface.Collections.CircularBuffer<TValue>`
* `PushTechnology.ClientInterface.IO.JSON.JSONToken`
* `PushTechnology.ClientInterface.IO.JSON.JSONReader`
* `PushTechnology.ClientInterface.Client.Session.ISessionId`
* `PushTechnology.ClientInterface.Client.Session.SessionException`
* `PushTechnology.ClientInterface.Client.Features.ClusterRepartitionException`
* `PushTechnology.ClientInterface.Client.Features.HandlerConflictException`
* `PushTechnology.ClientInterface.Client.Features.CallbackDefault`
* `PushTechnology.ClientInterface.Client.Features.ContextCallbackDefault<TContext>`
* `PushTechnology.ClientInterface.Client.Features.PingContextCallbackDefault<TContext>`
* `PushTechnology.ClientInterface.Client.Features.StreamDefault`
* `PushTechnology.ClientInterface.Client.Features.ContextStreamDefault<TContext>`
* `PushTechnology.ClientInterface.Client.Features.TopicDetailsCallbackDefault`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IMissingTopicNotificationStream`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicEventStream`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.MissingTopicNotificationStreamDefault`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.TopicEventStreamDefault`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.TopicControlTopicEventListenerDefault`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.AddTopicResult`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.AddTopicException`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.InvalidTopicSpecificationException`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ReferencedTopicDoesNotExistException`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ExistingTopicException`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.InvalidTopicPathException`
* `PushTechnology.ClientInterface.Client.Callbacks.DefaultStream`

Methods added:

* `PushTechnology.ClientInterface.Data.IDataType.ToBytes(object)->IBytes`
* `PushTechnology.ClientInterface.Data.IDataType.CanReadAs(Type)->bool`
* `PushTechnology.ClientInterface.Data.IDataType.ReadAs(Type,byte[],int,int)->object`
* `PushTechnology.ClientInterface.Data.IDataType.ReadAs(Type,byte[])->object`
* `PushTechnology.ClientInterface.Data.IDataType.ReadAs(Type,IBytes)->object`
* `PushTechnology.ClientInterface.Data.IDataType<TValue>.ToBytes(TValue)->IBytes`
* `PushTechnology.ClientInterface.Data.IDataType<TValue>.CanReadAs<TResult>()->bool`
* `PushTechnology.ClientInterface.Data.IDataType<TValue>.ReadAs<TResult>(byte[],int,int)->TResult`
* `PushTechnology.ClientInterface.Data.IDataType<TValue>.ReadAs<TResult>(byte[])->TResult`
* `PushTechnology.ClientInterface.Data.IDataType<TValue>.ReadAs<TResult>(IBytes)->TResult`
* `PushTechnology.ClientInterface.Data.IDataTypes.DoubleFloat{get}->IDataType<double?>`
* `PushTechnology.ClientInterface.Data.IDataTypes.Int64{get}->IDataType<long?>`
* `PushTechnology.ClientInterface.Data.IDataTypes.String{get}->IDataType<string>`
* `PushTechnology.ClientInterface.Data.IDataTypes.RecordV2{get}->IRecordV2DataType`
* `PushTechnology.ClientInterface.Data.IDeltaType.ToBytes(object)->IBytes`
* `PushTechnology.ClientInterface.Data.IDeltaType.ReadDelta(IBytes)->object`
* `PushTechnology.ClientInterface.Data.IDeltaType<TValue, TDelta>.ToBytes(TDelta)->IBytes`
* `PushTechnology.ClientInterface.Data.IDeltaType<TValue, TDelta>.ReadDelta(IBytes)->TDelta`
* `PushTechnology.ClientInterface.Extensions.ArrayExtensions.IsSegmentEqual<TValue>(TValue[],int,TValue[],int,int)->bool`
* `PushTechnology.ClientInterface.Client.Session.ISession.Topics{get}->ITopics`
* `PushTechnology.ClientInterface.Client.Session.ISession.Ping{get}->IPings`
* `PushTechnology.ClientInterface.Client.Session.ISession.TopicControl{get}->ITopicControl`
* `PushTechnology.ClientInterface.Client.Session.ISession.SubscriptionControl{get}->ISubscriptionControl`
* `PushTechnology.ClientInterface.Client.Session.ISession.AuthenticationControl{get}->IAuthenticationControl`
* `PushTechnology.ClientInterface.Client.Session.ISession.SystemAuthenticationControl{get}->ISystemAuthenticationControl`
* `PushTechnology.ClientInterface.Client.Session.ISession.Security{get}->ISecurity`
* `PushTechnology.ClientInterface.Client.Session.ISession.TopicUpdateControl{get}->ITopicUpdateControl`
* `PushTechnology.ClientInterface.Client.Session.ISession.Messaging{get}->IMessaging`
* `PushTechnology.ClientInterface.Client.Session.ISession.MessagingControl{get}->IMessagingControl`
* `PushTechnology.ClientInterface.Client.Session.ISession.ClientControl{get}->IClientControl`
* `PushTechnology.ClientInterface.Client.Session.ISession.SecurityControl{get}->ISecurityControl`
* `PushTechnology.ClientInterface.Client.Features.IPings.PingServerAsync()->Task<IPingDetails>`
* `PushTechnology.ClientInterface.Client.Features.IPings.PingServerAsync(CancellationToken)->Task<IPingDetails>`
* `PushTechnology.ClientInterface.Client.Features.IPingDetails.RoundTripTimeSpan{get}->TimeSpan`
* `PushTechnology.ClientInterface.Client.Features.ITopics.SubscribeAsync(ITopicSelector)->Task`
* `PushTechnology.ClientInterface.Client.Features.ITopics.SubscribeAsync(ITopicSelector,CancellationToken)->Task`
* `PushTechnology.ClientInterface.Client.Features.ITopics.SubscribeAsync(string)->Task`
* `PushTechnology.ClientInterface.Client.Features.ITopics.SubscribeAsync(string,CancellationToken)->Task`
* `PushTechnology.ClientInterface.Client.Features.ITopics.UnsubscribeAsync(ITopicSelector)->Task`
* `PushTechnology.ClientInterface.Client.Features.ITopics.UnsubscribeAsync(ITopicSelector,CancellationToken)->Task`
* `PushTechnology.ClientInterface.Client.Features.ITopics.UnsubscribeAsync(string)->Task`
* `PushTechnology.ClientInterface.Client.Features.ITopics.UnsubscribeAsync(string,CancellationToken)->Task`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.AddTopicAsync(string,TopicType)->Task<AddTopicResult>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.AddTopicAsync(string,TopicType,CancellationToken)->Task<AddTopicResult>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.AddTopicAsync(string,ITopicSpecification)->Task<AddTopicResult>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.AddTopicAsync(string,ITopicSpecification,CancellationToken)->Task<AddTopicResult>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.RemoveTopicsAsync(string)->Task<object>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.RemoveTopicsAsync(string,CancellationToken)->Task<object>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.RemoveTopicsAsync(ITopicSelector)->Task<object>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.RemoveTopicsAsync(ITopicSelector,CancellationToken)->Task<object>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.RemoveTopicsWithSessionAsync(string)->Task<IRegistration>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.RemoveTopicsWithSessionAsync(string,CancellationToken)->Task<IRegistration>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.AddMissingTopicHandlerAsync(string,IMissingTopicNotificationStream)->Task<IRegistration>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.AddMissingTopicHandlerAsync(string,IMissingTopicNotificationStream,CancellationToken)->Task<IRegistration>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.AddTopicEventListenerAsync(string,ITopicEventStream)->Task<IRegistration>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.AddTopicEventListenerAsync(string,ITopicEventStream,CancellationToken)->Task<IRegistration>`

Fields added:

* `PushTechnology.ClientInterface.Client.Features.Control.Topics.TopicAddFailReason.CLUSTER_REPARTITION`
* `PushTechnology.ClientInterface.Client.Topics.TopicType.STRING`
* `PushTechnology.ClientInterface.Client.Topics.TopicType.INT64`
* `PushTechnology.ClientInterface.Client.Topics.TopicType.DOUBLE`
* `PushTechnology.ClientInterface.Client.Topics.TopicType.RECORD_V2`
* `PushTechnology.ClientInterface.Client.Topics.Details.TopicSpecificationProperty.SlaveMasterTopic`
* `PushTechnology.ClientInterface.Client.Topics.Details.TopicSpecificationProperty.TidyOnUnsubscribe`
* `PushTechnology.ClientInterface.Client.Topics.Details.TopicSpecificationProperty.Schema`
* `PushTechnology.ClientInterface.Client.Callbacks.ErrorReason.UNSUPPORTED`
* `PushTechnology.ClientInterface.Client.Callbacks.ErrorReason.INVALID_DATA`
* `PushTechnology.ClientInterface.Client.Callbacks.ErrorReason.NO_SUCH_SESSION`
* `PushTechnology.ClientInterface.Client.Callbacks.ErrorReason.INCOMPATIBLE_DATATYPE`
* `PushTechnology.ClientInterface.Client.Callbacks.ErrorReason.UNHANDLED_MESSAGE`
* `PushTechnology.ClientInterface.Client.Callbacks.ErrorReason.CLUSTER_REPARTITION`
* `PushTechnology.ClientInterface.Client.Callbacks.ErrorReason.INCOMPATIBLE_STATE`
* `PushTechnology.ClientInterface.Client.Callbacks.ErrorReason.HANDLER_CONFLICT`

Types removed:

* `PushTechnology.ClientInterface.Client.Args.AcknowledgementEventArgs`
* `PushTechnology.ClientInterface.Client.Args.CredentialsRejectedEventArgs`
* `PushTechnology.ClientInterface.Client.Content.ContentFactoryImpl`
* `PushTechnology.ClientInterface.Client.Content.Metadata.Record.IMStringImplAbstractStringBuilder`
* `PushTechnology.ClientInterface.Client.Content.Metadata.MetadataContextImpl`
* `PushTechnology.ClientInterface.Client.Content.Metadata.MetadataDefaultsImpl`
* `PushTechnology.ClientInterface.Client.Content.Metadata.Record.MetadataCodecImpl`
* `PushTechnology.ClientInterface.Client.Content.Metadata.Record.MetadataFactoryImpl`
* `PushTechnology.ClientInterface.Client.Topics.Update.IUpdate`
* `PushTechnology.ClientInterface.Client.Topics.Update.IUpdateFactory`
* `PushTechnology.ClientInterface.Client.Topics.Update.IContentUpdateFactory`
* `PushTechnology.ClientInterface.Client.Topics.Update.IPagedUpdateFactory`
* `PushTechnology.ClientInterface.Client.Topics.Update.IPagedRecordOrderedUpdateFactory`
* `PushTechnology.ClientInterface.Client.Topics.Update.IPagedUnorderedUpdateFactory`
* `PushTechnology.ClientInterface.Client.Topics.Update.IPagedRecordUnorderedUpdateFactory`
* `PushTechnology.ClientInterface.Client.Topics.Update.IPagedStringOrderedUpdateFactory`
* `PushTechnology.ClientInterface.Client.Topics.Update.IPagedStringUnorderedUpdateFactory`
* `PushTechnology.ClientInterface.Client.Topics.Update.IUpdateBuilder<T>`
* `PushTechnology.ClientInterface.Client.Content.Update.UpdateFactoriesImpl`
* `PushTechnology.ClientInterface.Client.Content.Update.UpdateRequestType`
* `PushTechnology.ClientInterface.Client.Content.Update.UpdateRequestType.UpdateRequestTypeEnum`
* `PushTechnology.ClientInterface.Client.Enums.TopicProperty`
* `PushTechnology.ClientInterface.Client.Enums.TopicProperty.TopicPropertyEnum`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISessionDetailsCallback`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISessionDetailsContextCallback<T>`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.ISessionDetailsListener`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.SessionDetailsContextCallbackDefault<T>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IPagingControlUpdater<T>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControlRemoveCallback`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControlRemoveContextCallback<T>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.TopicControlRemoveCallbackDefault`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.TopicControlRemoveContextCallbackDefault<T>`
* `PushTechnology.ClientInterface.Client.Features.IAckFeatureHandler`
* `PushTechnology.ClientInterface.Client.Features.IAcks`
* `PushTechnology.ClientInterface.Client.Features.IFeatureFactory<T0,T1,T2>`
* `PushTechnology.ClientInterface.Client.Features.IRequesterFeatureError`
* `PushTechnology.ClientInterface.Client.Features.IRequesterFeatureHandler`
* `PushTechnology.ClientInterface.Client.Features.IRequesterFeatureResponse`
* `PushTechnology.ClientInterface.Client.Features.IRequesterFeatureResponseHandler`
* `PushTechnology.ClientInterface.Client.Features.IServiceTopic`
* `PushTechnology.ClientInterface.Client.Features.RequesterFeatureError`
* `PushTechnology.ClientInterface.Client.Features.RequesterFeatureError.RequesterServiceErrorEnum`
* `PushTechnology.ClientInterface.Client.Features.TopicDefinition`
* `PushTechnology.ClientInterface.Client.IClientId`
* `PushTechnology.ClientInterface.Client.IReceiveOptions`
* `PushTechnology.ClientInterface.Client.ISessionEvents`
* `PushTechnology.ClientInterface.Client.Session.ISessionListener`
* `PushTechnology.ClientInterface.Client.Topics.IChildListTopicDetails`
* `PushTechnology.ClientInterface.Client.Topics.IChildListTopicDetailsSchema`
* `PushTechnology.ClientInterface.Client.Topics.IChildListTopicDetailsAttributes`
* `PushTechnology.ClientInterface.Client.Topics.IChildListTopicDetailsBuilder`
* `PushTechnology.ClientInterface.Client.Topics.ICustomTopicDetails`
* `PushTechnology.ClientInterface.Client.Topics.IPagedTopicOrderingPolicy`
* `PushTechnology.ClientInterface.Client.Topics.IPagedTopicOrderedOrderingPolicy`
* `PushTechnology.ClientInterface.Client.Topics.IPagedRecordOrderingPolicy`
* `PushTechnology.ClientInterface.Client.Topics.IPagedTopicDetails`
* `PushTechnology.ClientInterface.Client.Topics.IPagedRecordTopicDetails`
* `PushTechnology.ClientInterface.Client.Topics.IPagedTopicDetailsAttributes`
* `PushTechnology.ClientInterface.Client.Topics.IPagedRecordTopicDetailsAttributes`
* `PushTechnology.ClientInterface.Client.Topics.IPagedTopicDetailsBuilder<T0,T1>`
* `PushTechnology.ClientInterface.Client.Topics.IPagedRecordTopicDetailsBuilder`
* `PushTechnology.ClientInterface.Client.Topics.IPagedRecordTopicDetailsSchema`
* `PushTechnology.ClientInterface.Client.Topics.IPagedStringTopicDetails`
* `PushTechnology.ClientInterface.Client.Topics.IPagedStringTopicDetailsAttributes`
* `PushTechnology.ClientInterface.Client.Topics.IPagedStringTopicDetailsBuilder`
* `PushTechnology.ClientInterface.Client.Topics.IPagedStringTopicDetailsSchema`
* `PushTechnology.ClientInterface.Client.Topics.IPagedTopicDetailsAttributesComparatorOrderingPolicy`
* `PushTechnology.ClientInterface.Client.Topics.IPagedTopicRules`
* `PushTechnology.ClientInterface.Client.Topics.PagedTopicNoRules`
* `PushTechnology.ClientInterface.Client.Topics.IProtocolBufferTopicDetails`
* `PushTechnology.ClientInterface.Client.Topics.IProtocolBufferTopicDetailsAttributes`
* `PushTechnology.ClientInterface.Client.Topics.IProtocolBufferTopicDetailsBuilder`
* `PushTechnology.ClientInterface.Client.Topics.IProtocolBufferTopicDetailsSchema`
* `PushTechnology.ClientInterface.Client.Topics.IServiceTopicDetails`
* `PushTechnology.ClientInterface.Client.Topics.IServiceTopicDetailsAttributes`
* `PushTechnology.ClientInterface.Client.Topics.IServiceTopicDetailsBuilder`
* `PushTechnology.ClientInterface.Client.Topics.IServiceTopicDetailsSchema`
* `PushTechnology.ClientInterface.Client.Topics.ITopicNotifyTopicBuilder`
* `PushTechnology.ClientInterface.Client.Topics.ITopicNotifyTopicDetails`
* `PushTechnology.ClientInterface.Client.Topics.ITopicNotifyTopicDetailsAttributes`
* `PushTechnology.ClientInterface.Client.Topics.ITopicNotifyTopicDetailsBuilder`
* `PushTechnology.ClientInterface.Client.Topics.ITopicNotifyTopicDetailsSchema`
* `PushTechnology.ClientInterface.Client.Topics.PagedRecordOrderKey`
* `PushTechnology.ClientInterface.Client.Topics.PagedTopicCollationRules`
* `PushTechnology.ClientInterface.Client.Topics.PagedTopicDuplicates`
* `PushTechnology.ClientInterface.Client.Topics.PagedTopicOrder`
* `PushTechnology.ClientInterface.Client.Topics.PagedTopicOrdering`
* `PushTechnology.ClientInterface.Client.Topics.PagedTopicRuleType`
* `PushTechnology.ClientInterface.Client.Topics.ProtocolBufferTopicUpdateMode`
* `PushTechnology.ClientInterface.Client.Topics.Update.IContentUpdateBuilder`
* `PushTechnology.ClientInterface.Client.Topics.Update.UpdateType`
* `PushTechnology.ClientInterface.Client.Topics.Update.UpdateType.UpdateTypeEnum`
* `PushTechnology.ClientInterface.Conversation.Command.Sender.ClosedServiceException`
* `PushTechnology.ClientInterface.Conversation.Command.StatusResponseStatus`
* `PushTechnology.ClientInterface.Conversation.Conversation.ConversationResult`
* `PushTechnology.DiffusionCore.AdvancedEnum`
* `PushTechnology.DiffusionCore.Base64`
* `PushTechnology.DiffusionCore.Buffering.ByteBufferBase`
* `PushTechnology.DiffusionCore.Buffering.IByteBufferAllocator`
* `PushTechnology.DiffusionCore.Buffering.ByteBufferAllocator`
* `PushTechnology.DiffusionCore.Buffering.ByteBufferFactory`
* `PushTechnology.DiffusionCore.Buffering.ByteBufferHexDumper`
* `PushTechnology.DiffusionCore.Buffering.MessageByteBuffer`
* `PushTechnology.DiffusionCore.Buffering.NewByteBuffer`
* `PushTechnology.DiffusionCore.Connection.Common.IO.Serialisation.IByteBufferSerialiser<T>`
* `PushTechnology.DiffusionCore.Connection.ConnectionCapabilities`
* `PushTechnology.DiffusionCore.Connection.Interfaces.IConnectionDetails`
* `PushTechnology.DiffusionCore.Connection.Connectors.Connection.ConnectionDetailsImpl`
* `PushTechnology.DiffusionCore.Connection.Connectors.Connection.ConnectionFactory`
* `PushTechnology.DiffusionCore.Connection.IDiffusionMessagingConnector`
* `PushTechnology.DiffusionCore.Connection.Interfaces.IDiffusionClientConnector`
* `PushTechnology.DiffusionCore.Connection.Connectors.IDiffusionBufferMessageHandler`
* `PushTechnology.DiffusionCore.Connection.Connectors.IConnectionHandler`
* `PushTechnology.DiffusionCore.Messaging.IMessageSource`
* `PushTechnology.DiffusionCore.Connection.Connectors.IClientConnectionHandler`
* `PushTechnology.DiffusionCore.Connection.Interfaces.ISyncMessageHandler`
* `PushTechnology.DiffusionCore.Connection.Interfaces.IDiffusionClientEvents`
* `PushTechnology.DiffusionCore.Connection.Interfaces.IDiffusionClientEventMethods`
* `PushTechnology.DiffusionCore.Connection.Connectors.IDiffusionClientTcpConnection`
* `PushTechnology.DiffusionCore.Connection.Connectors.ExternalClient.HttpConstants`
* `PushTechnology.DiffusionCore.Connection.Connectors.ExternalClient.Notify.ITopicNotifyTopicHandler`
* `PushTechnology.DiffusionCore.Connection.Connectors.ExternalClient.Notify.ITopicNotifyTopicListener`
* `PushTechnology.DiffusionCore.Connection.Connectors.ExternalClient.Notify.MetadataType`
* `PushTechnology.DiffusionCore.Connection.Connectors.ExternalClient.Notify.NotificationLevel`
* `PushTechnology.DiffusionCore.Connection.Connectors.ExternalClient.Notify.NotificationLevel.Notification`
* `PushTechnology.DiffusionCore.Connection.Connectors.ExternalClient.Notify.SelectionMode`
* `PushTechnology.DiffusionCore.Connection.Connectors.ExternalClient.Notify.SelectionMode.Mode`
* `PushTechnology.DiffusionCore.Connection.Connectors.ExternalClient.Notify.TopicNotifyIO`
* `PushTechnology.DiffusionCore.Messaging.Topic.ITopicListener`
* `PushTechnology.DiffusionCore.Connection.Connectors.ExternalClient.Notify.TopicNotifyTopicHandlerImpl`
* `PushTechnology.DiffusionCore.Connection.Connectors.ExternalClient.Paging.ILines`
* `PushTechnology.DiffusionCore.Connection.Connectors.ExternalClient.Paging.IPagedTopicHandler`
* `PushTechnology.DiffusionCore.Connection.Connectors.ExternalClient.Paging.IPagedTopicListener`
* `PushTechnology.DiffusionCore.Connection.Connectors.ExternalClient.Paging.IPageStatus`
* `PushTechnology.DiffusionCore.Connection.Connectors.ExternalClient.Paging.PageOption`
* `PushTechnology.DiffusionCore.Connection.Connectors.ExternalClient.Service.IServiceTopicError`
* `PushTechnology.DiffusionCore.Connection.Connectors.ExternalClient.Service.IServiceTopicHandler`
* `PushTechnology.DiffusionCore.Connection.Connectors.ExternalClient.Service.IServiceTopicListener`
* `PushTechnology.DiffusionCore.Connection.Connectors.ExternalClient.Service.IServiceTopicResponse`
* `PushTechnology.DiffusionCore.Connection.Connectors.ExternalClient.Service.ServiceErrorType`
* `PushTechnology.DiffusionCore.Connection.Connectors.IDiffusionListenerBase`
* `PushTechnology.DiffusionCore.Connection.Connectors.IDiffusionBaseConnector`
* `PushTechnology.DiffusionCore.Connection.IServerDetails`
* `PushTechnology.DiffusionCore.Connection.ServerDetailsImpl`
* `PushTechnology.DiffusionCore.Connection.HttpServerDetailsImpl`
* `PushTechnology.DiffusionCore.Connection.HttpSslServerDetailsImpl`
* `PushTechnology.DiffusionCore.Connection.ICascadable`
* `PushTechnology.DiffusionCore.Connection.IDiffusionBufferMessageHandler`
* `PushTechnology.DiffusionCore.Connection.IDiffusionTopicConnector`
* `PushTechnology.ClientInterface.Core.Connection.Interfaces.IClientConnector`
* `PushTechnology.DiffusionCore.Connection.Interfaces.IDiffusionConnectorEvents`
* `PushTechnology.DiffusionCore.Connection.Interfaces.IServerConnectionListener`
* `PushTechnology.DiffusionCore.Connection.Interfaces.IServerPingResponseListener`
* `PushTechnology.DiffusionCore.Connection.IProxyConnector`
* `PushTechnology.DiffusionCore.Connection.ServerConnectionState`
* `PushTechnology.DiffusionCore.Connection.ServerDetailsEventArgs`
* `PushTechnology.DiffusionCore.Connection.ServerDetailsFactory`
* `PushTechnology.DiffusionCore.Connection.ServerDetailsHost`
* `PushTechnology.DiffusionCore.Persistence.BaseDetailsLoader`
* `PushTechnology.DiffusionCore.Connection.ServerDetailsLoader`
* `PushTechnology.DiffusionCore.Connection.Services.IDiffusionReconnectorEvents`
* `PushTechnology.DiffusionCore.Connection.Services.DiffusionConnectionHelper`
* `PushTechnology.DiffusionCore.Connection.Services.DiffusionConnectionService<T>`
* `PushTechnology.DiffusionCore.Connection.Services.DiffusionConnectionServiceEventArgs`
* `PushTechnology.DiffusionCore.Connection.Services.DiffusionPingService`
* `PushTechnology.DiffusionCore.Connection.Services.DiffusionReconnectionEventArgs`
* `PushTechnology.DiffusionCore.Connection.Services.IDiffusionPingService`
* `PushTechnology.DiffusionCore.Connection.Services.IDiffusionReconnector`
* `PushTechnology.DiffusionCore.Connection.Services.PingServiceEventArgs`
* `PushTechnology.DiffusionCore.Connection.Sockets.ClientSocket`
* `PushTechnology.DiffusionCore.Connection.Sockets.Enums.DiffusionSocketError`
* `PushTechnology.DiffusionCore.Connection.Sockets.MessageEventArgs`
* `PushTechnology.DiffusionCore.Connection.TcpServerDetailsImpl`
* `PushTechnology.DiffusionCore.Connection.TcpSslServerDetailsImpl`
* `PushTechnology.DiffusionCore.Connection.TransportProtocol`
* `PushTechnology.DiffusionCore.Connection.WebSocketServerDetailsImpl`
* `PushTechnology.DiffusionCore.Connection.WebSocketSSLServerDetailsImpl`
* `PushTechnology.DiffusionCore.Enums.ClientTransportType`
* `PushTechnology.DiffusionCore.Enums.DiffusionMessageType`
* `PushTechnology.DiffusionCore.Enums.MessageEncodingType`
* `PushTechnology.DiffusionCore.Exceptions.ClientException`
* `PushTechnology.DiffusionCore.Exceptions.OutboundConnectionException`
* `PushTechnology.DiffusionCore.ExtensionMethods.Events`
* `PushTechnology.DiffusionCore.ExtensionMethods.List`
* `PushTechnology.DiffusionCore.ExtensionMethods.ObjectCloning`
* `PushTechnology.DiffusionCore.ExtensionMethods.Utils`
* `PushTechnology.DiffusionCore.FastCrypt`
* `PushTechnology.DiffusionCore.LongPath.LongPathDirectory`
* `PushTechnology.DiffusionCore.LongPath.LongPathFile`
* `PushTechnology.DiffusionCore.Messaging.Ack.IServerAckListener`
* `PushTechnology.DiffusionCore.Messaging.Ack.ServerAckManager`
* `PushTechnology.DiffusionCore.Messaging.Ack.ThreadingHandleContainer`
* `PushTechnology.ClientInterface.Messaging.IMessage`
* `PushTechnology.DiffusionCore.Messaging.IMessageComparable`
* `PushTechnology.DiffusionCore.Messaging.MessageBase`
* `PushTechnology.DiffusionCore.Messaging.MessageImpl`
* `PushTechnology.ClientInterface.Messaging.IDataMessage`
* `PushTechnology.DiffusionCore.Messaging.DataMessageImpl`
* `PushTechnology.ClientInterface.Messaging.ITopicMessage`
* `PushTechnology.DiffusionCore.Messaging.Topic.TopicMessageImpl`
* `PushTechnology.DiffusionCore.Messaging.Topic.TopicLoadMessage`
* `PushTechnology.DiffusionCore.Messaging.CommandLoadMessage`
* `PushTechnology.DiffusionCore.Messaging.DeltaMessage`
* `PushTechnology.DiffusionCore.Messaging.CommandMessage`
* `PushTechnology.DiffusionCore.Messaging.CommandNotificationMessage`
* `PushTechnology.DiffusionCore.Messaging.DataMessageInputStream`
* `PushTechnology.DiffusionCore.Messaging.DataMessageOutputStream`
* `PushTechnology.DiffusionCore.Messaging.Data.metadata.ICustomFieldHandler`
* `PushTechnology.DiffusionCore.Messaging.Data.metadata.IMNode`
* `PushTechnology.DiffusionCore.Messaging.Data.metadata.IMField`
* `PushTechnology.DiffusionCore.Messaging.Data.metadata.IMRecord`
* `PushTechnology.DiffusionCore.Messaging.Data.metadata.IMMessage`
* `PushTechnology.DiffusionCore.Messaging.Data.metadata.MDataType`
* `PushTechnology.DiffusionCore.Messaging.Data.metadata.MetadataFactory`
* `PushTechnology.DiffusionCore.Messaging.Data.metadata.MNodeImpl`
* `PushTechnology.DiffusionCore.Messaging.Data.metadata.MFieldImpl`
* `PushTechnology.DiffusionCore.Messaging.Data.metadata.MFieldCustomString`
* `PushTechnology.DiffusionCore.Messaging.Data.metadata.MFieldDecimalString`
* `PushTechnology.DiffusionCore.Messaging.Data.metadata.MFieldIntegerString`
* `PushTechnology.DiffusionCore.Messaging.Data.metadata.MFieldString`
* `PushTechnology.DiffusionCore.Messaging.Data.metadata.MRecordImpl`
* `PushTechnology.DiffusionCore.Messaging.Data.metadata.MMessageImpl`
* `PushTechnology.DiffusionCore.Messaging.Data.metadata.Multiplicity`
* `PushTechnology.DiffusionCore.Messaging.Data.metadata.record.MRecordMessage`
* `PushTechnology.DiffusionCore.Messaging.Data.metadata.record.MRecordRecord`
* `PushTechnology.DiffusionCore.Messaging.Data.Paging.LinesRecord`
* `PushTechnology.DiffusionCore.Messaging.Data.Paging.LinesString`
* `PushTechnology.DiffusionCore.Messaging.Data.Paging.PagedClient`
* `PushTechnology.DiffusionCore.Messaging.Data.Paging.PagedTopicHandlerImpl`
* `PushTechnology.DiffusionCore.Messaging.Data.Paging.PageStatusImpl`
* `PushTechnology.DiffusionCore.Messaging.Data.record.RecordData`
* `PushTechnology.DiffusionCore.Messaging.Data.record.RecordDataKey`
* `PushTechnology.DiffusionCore.Messaging.Data.Service.ServiceTopicErrorImpl`
* `PushTechnology.DiffusionCore.Messaging.Data.Service.ServiceTopicHandlerImpl`
* `PushTechnology.DiffusionCore.Messaging.Data.Service.ServiceTopicResponseImpl`
* `PushTechnology.DiffusionCore.Messaging.Data.TopicDataType`
* `PushTechnology.DiffusionCore.Messaging.Data.TopicDataType.DataType`
* `PushTechnology.DiffusionCore.Messaging.DeltaMessageAck`
* `PushTechnology.DiffusionCore.Messaging.Encoding.MessageConverter`
* `PushTechnology.DiffusionCore.Messaging.Encoding.MessageBase64Decoder`
* `PushTechnology.DiffusionCore.Messaging.Encoding.MessageBase64Encoder`
* `PushTechnology.DiffusionCore.Messaging.Encoding.MessageCompressor`
* `PushTechnology.DiffusionCore.Messaging.Encoding.MessageDecompressor`
* `PushTechnology.DiffusionCore.Messaging.Encoding.MessageDecrypter`
* `PushTechnology.DiffusionCore.Messaging.Encoding.MessageEncrypter`
* `PushTechnology.DiffusionCore.Messaging.Encoding.MessageEncryption`
* `PushTechnology.DiffusionCore.Messaging.Enums.MessageSourceType`
* `PushTechnology.DiffusionCore.Messaging.Enums.TopicStatus`
* `PushTechnology.DiffusionCore.Messaging.FetchReplyMessage`
* `PushTechnology.DiffusionCore.Messaging.IExternalMessage`
* `PushTechnology.DiffusionCore.Messaging.IMessageHeaderTransformer`
* `PushTechnology.DiffusionCore.Messaging.IMessageParser`
* `PushTechnology.DiffusionCore.Messaging.MessageComparator`
* `PushTechnology.DiffusionCore.Messaging.MessageEventArgs<T>`
* `PushTechnology.DiffusionCore.Messaging.MessageFactory`
* `PushTechnology.DiffusionCore.Messaging.MessageParser`
* `PushTechnology.DiffusionCore.Messaging.MessageToClientParser`
* `PushTechnology.DiffusionCore.Messaging.MessageUtils`
* `PushTechnology.DiffusionCore.Messaging.Record`
* `PushTechnology.DiffusionCore.Messaging.DiffusionConnectorState`
* `PushTechnology.DiffusionCore.Messaging.ServerClosedEventArgs`
* `PushTechnology.DiffusionCore.Messaging.ServerRejectedCredentialsEventArgs`
* `PushTechnology.DiffusionCore.Messaging.Services.ITimedMessageSender`
* `PushTechnology.DiffusionCore.Messaging.Services.MessageArgsContainer`
* `PushTechnology.DiffusionCore.Messaging.Services.MessageCreatorSendEventArgs`
* `PushTechnology.DiffusionCore.Messaging.Services.MessageFactoryHelper`
* `PushTechnology.DiffusionCore.Messaging.Services.TimedMessageSendingService`
* `PushTechnology.DiffusionCore.Messaging.TopicLoadMessageAck`
* `PushTechnology.DiffusionCore.Messaging.Topic.ITopicDeletionListener`
* `PushTechnology.ClientInterface.Messaging.ControlMessage`
* `PushTechnology.ClientInterface.Messaging.TopicControlMessage`
* `PushTechnology.DiffusionCore.Messaging.Topic.TopicAddMessage`
* `PushTechnology.DiffusionCore.Messaging.Topic.TopicAliasing`
* `PushTechnology.DiffusionCore.Messaging.Topic.TopicAliasMap`
* `PushTechnology.DiffusionCore.Messaging.Topic.TopicDataType`
* `PushTechnology.DiffusionCore.Messaging.Topic.TopicDefinition`
* `PushTechnology.DiffusionCore.Messaging.Topic.TopicListenerImpl`
* `PushTechnology.DiffusionCore.Messaging.Topic.TopicListeners`
* `PushTechnology.DiffusionCore.Messaging.Topic.TopicMessageComparator`
* `PushTechnology.DiffusionCore.Messaging.Topic.TopicMessageComparators`
* `PushTechnology.DiffusionCore.Messaging.Topic.TopicProperty`
* `PushTechnology.DiffusionCore.Messaging.Topic.TopicSelector`
* `PushTechnology.DiffusionCore.Messaging.Topic.TopicSelector.SelectorType`
* `PushTechnology.DiffusionCore.Messaging.Topic.TopicSelectorAll`
* `PushTechnology.DiffusionCore.Messaging.Topic.TopicSelectorName`
* `PushTechnology.DiffusionCore.Messaging.Topic.TopicSelectorPatterns`
* `PushTechnology.DiffusionCore.Messaging.Topic.TopicSelectorSinglePattern`
* `PushTechnology.DiffusionCore.Messaging.Topic.TopicSet`
* `PushTechnology.DiffusionCore.Messaging.WebSocketMessageToClientParser`
* `PushTechnology.DiffusionCore.Messaging.WebSocketTopicMessage`
* `PushTechnology.DiffusionCore.Persistence.IsolatedStorageUtils`
* `PushTechnology.DiffusionCore.PropertyHandlers.APIProperties`
* `PushTechnology.DiffusionCore.PropertyHandler.IPropertyHandler`
* `PushTechnology.DiffusionCore.PropertyHandler.PropertyHandlerImpl`
* `PushTechnology.DiffusionCore.PropertyHandler.BaseProperties`
* `PushTechnology.DiffusionCore.PropertyHandlers.DiffusionProperties`
* `PushTechnology.DiffusionCore.PropertyHandler.DynamicProperty<T>`
* `PushTechnology.DiffusionCore.PropertyHandler.ComplexProperty<T>`
* `PushTechnology.DiffusionCore.PropertyHandler.JavaProperties`
* `PushTechnology.DiffusionCore.PropertyHandler.Properties`
* `PushTechnology.DiffusionCore.PropertyHandler.SimpleProperty<T>`
* `PushTechnology.DiffusionCore.Threading.LimitedConcurrencyLevelTaskScheduler`
* `PushTechnology.DiffusionCore.Threading.Locks`
* `PushTechnology.DiffusionCore.Threading.DevPlanetLock`
* `PushTechnology.DiffusionCore.Threading.ReadLock`
* `PushTechnology.DiffusionCore.Threading.ReadOnlyLock`
* `PushTechnology.DiffusionCore.Threading.WriteLock`
* `PushTechnology.DiffusionCore.Threading.ThreadSafeList<T>`
* `PushTechnology.DiffusionCore.Timing.TimerStartException`
* `PushTechnology.DiffusionCore.Utilities.EnumerableHelpers`
* `PushTechnology.DiffusionCore.Utilities.Nothing`
* `PushTechnology.DiffusionCore.V4Credentials`
* `PushTechnology.DiffusionExternalClient.ExternalClient`
* `PushTechnology.ClientInterface.Logging.Logger`
* `PushTechnology.ClientInterface.TopicDetails.Details.ICustomTopicDetailsAttributes`
* `PushTechnology.ClientInterface.TopicDetails.Details.ICustomTopicDetailsBuilder`
* `PushTechnology.ClientInterface.TopicDetails.Details.ICustomTopicDetailsSchema`
* `PushTechnology.ClientInterface.TopicDetails.Details.IPagedStringTopicOrderingPolicy`
* `PushTechnology.ClientInterface.TopicDetails.Details.TopicPropertyKey`
* `PushTechnology.ClientInterface.Utils.ActionExtensions`
* `PushTechnology.ClientInterface.Utils.ExpressionHelper`
* `PushTechnology.ClientInterface.Utils.HashSetExtensions`
* `PushTechnology.ClientInterface.Utils.StringUtils`
* `PushTechnology.ClientInterface.Messaging.AbortNotificationMessage`
* `PushTechnology.ClientInterface.Messaging.AckMessage`
* `PushTechnology.ClientInterface.Messaging.IPingMessage`
* `PushTechnology.ClientInterface.Messaging.PingMessageImpl`
* `PushTechnology.ClientInterface.Messaging.ClientPingMessageImpl`
* `PushTechnology.ClientInterface.Messaging.CloseRequestMessage`
* `PushTechnology.ClientInterface.Messaging.CredentialsMessage`
* `PushTechnology.ClientInterface.Messaging.CredentialsRejectedMessage`
* `PushTechnology.ClientInterface.Messaging.Encoding.MessageCodecs`
* `PushTechnology.ClientInterface.Messaging.IMessageReader`
* `PushTechnology.ClientInterface.Messaging.MessageConstants`
* `PushTechnology.ClientInterface.Messaging.MessageEncoding`
* `PushTechnology.ClientInterface.Messaging.FetchMessage`
* `PushTechnology.ClientInterface.Messaging.IClientPingMessage`
* `PushTechnology.ClientInterface.Messaging.IInternalMessage`
* `PushTechnology.ClientInterface.Messaging.InternalMessage`
* `PushTechnology.ClientInterface.Messaging.IServerPingMessage`
* `PushTechnology.ClientInterface.Messaging.MessageReader`
* `PushTechnology.ClientInterface.Messaging.RecordsFieldsReader`
* `PushTechnology.ClientInterface.Messaging.ServerPingMessageImpl`
* `PushTechnology.ClientInterface.Messaging.TopicRemoveMessage`
* `PushTechnology.ClientInterface.Messaging.TopicStatusMessage`

Methods removed:

* `PushTechnology.ClientInterface.Client.Content.Metadata.IMetadataDefaults.DefaultRecordMetadata{get}->...`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IClientControl.SetSessionDetailsListener(...)->...`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IClientControl.GetSessionDetails(...)->...`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IClientControl.Close(...)->...`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicControl.RemoveTopics(...)->...`
* `PushTechnology.ClientInterface.Client.Features.ITopics.RemoveTopicStream(...)->...`
* `PushTechnology.DiffusionCore.Client.Types.ICredentialsFactory.CreateNoCredentials()->ICredentials`
* `PushTechnology.DiffusionCore.Client.Types.ICredentialsFactory.CreatePasswordCredentials(string)->ICredentials`
* `PushTechnology.DiffusionCore.Client.Types.ICredentialsFactory.CreateCustomCredentials(byte[])->ICredentials`
* `PushTechnology.ClientInterface.Client.Session.ISession.Start()->()`
* `PushTechnology.ClientInterface.Client.Topics.TopicType.Stateful{get}->TopicType`
* `PushTechnology.ClientInterface.Client.Topics.TopicType.Functional{get}->TopicType`

Fields removed:

* `PushTechnology.ClientInterface.Client.Content.Xml.MetadataTopicDataType.PROTOCOL_BUFFER`
* `PushTechnology.ClientInterface.Client.Content.Xml.MetadataTopicDataType.CUSTOM`
* `PushTechnology.ClientInterface.Client.Content.Xml.MetadataTopicDataType.CHILD_LIST`
* `PushTechnology.ClientInterface.Client.Content.Xml.MetadataTopicDataType.DIFF`
* `PushTechnology.ClientInterface.Client.Content.Xml.MetadataTopicDataType.PAGED_STRING`
* `PushTechnology.ClientInterface.Client.Content.Xml.MetadataTopicDataType.PAGED_RECORD`
* `PushTechnology.ClientInterface.Client.Content.Xml.MetadataTopicDataType.TOPIC_NOTIFY`
* `PushTechnology.ClientInterface.Client.Content.Xml.MetadataTopicDataType.SERVICE`
* `PushTechnology.ClientInterface.Client.Content.Xml.MetadataTopicDataType.REMOTE_CONTROL`
* `PushTechnology.ClientInterface.Client.Content.Xml.MetadataTopicDataType.REMOTE_SERVICE`
* `PushTechnology.ClientInterface.Client.Content.Xml.MetadataTopicDataType.REMOTE_CONTROL_RELAY`
* `PushTechnology.ClientInterface.Client.Content.Xml.MetadataTopicDataType.REMOTE_SERVICE_RELAY`
* `PushTechnology.ClientInterface.Client.Session.SessionState.CONNECTED_INITIALISING`
* `PushTechnology.ClientInterface.Client.Session.SessionState.RECOVERING_FAILOVER`
* `PushTechnology.ClientInterface.Client.Topics.TopicType.PROTOCOL_BUFFER`
* `PushTechnology.ClientInterface.Client.Topics.TopicType.CUSTOM`
* `PushTechnology.ClientInterface.Client.Topics.TopicType.SERVICE`
* `PushTechnology.ClientInterface.Client.Topics.TopicType.PAGED_STRING`
* `PushTechnology.ClientInterface.Client.Topics.TopicType.PAGED_RECORD`
* `PushTechnology.ClientInterface.Client.Topics.TopicType.TOPIC_NOTIFY`
* `PushTechnology.ClientInterface.Client.Topics.TopicType.CHILD_LIST`

Marked obsolete:

* `PushTechnology.ClientInterface.Client.Topics.ITopicDetails`
* `PushTechnology.ClientInterface.Client.Topics.ISlaveTopicDetails`
* `PushTechnology.ClientInterface.TopicDetails.Details.IRoutingTopicDetails`
* `PushTechnology.ClientInterface.Client.Topics.TopicType.STATELESS`
* `PushTechnology.ClientInterface.Client.Topics.IStatelessTopicDetails`
* `PushTechnology.ClientInterface.Client.Content.Update.IContentUpdateFactory`
* `PushTechnology.ClientInterface.Client.Features.ITopics.AddTopicStream(ITopicSelector,ITopicStream)->void`
* `PushTechnology.ClientInterface.Client.Features.ITopics.AddTopicStream(string,ITopicStream)->void`
* `PushTechnology.ClientInterface.Client.Features.ITopics.AddFallbackTopicStream(ITopicStream)->void`
* `PushTechnology.ClientInterface.Client.Features.ITopicStream`
* `PushTechnology.ClientInterface.Client.Features.TopicStreamDefault`
* `PushTechnology.ClientInterface.Client.Content.TopicDataType`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IStatelessSubscriptionRequestHandler`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IStatelessSubscriptionRequest`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ISubscriptionRequest`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicManagementHandler`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.ITopicManagementFactory`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IStateListener`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IQueueListener`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IClientControlFeatureHandler`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IAuthControlFeatureHandler`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IClientInfo`
* `PushTechnology.ClientInterface.Client.Features.Control.Clients.IClientSession`
* `PushTechnology.ClientInterface.Client.Session.SessionId`
* `PushTechnology.ClientInterface.Client.Content.Metadata.Record.IMNodeBuilder`
* `PushTechnology.ClientInterface.Client.Content.Metadata.Record.IMStringAbstractStringBuilder`
* `PushTechnology.ClientInterface.Client.Content.Metadata.Record.MetadataCodec`
* `PushTechnology.ClientInterface.Client.Content.Metadata.Record.MetadataFactory`
* `PushTechnology.ClientInterface.Client.Content.Metadata.ICustomFieldHandler`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IMContent`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IMContentBuilder`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IMCustomString`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IMCustomStringBuilder`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IMDecimalString`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IMDecimalStringBuilder`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IMetadataCodec`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IMetadataContext`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IMetadataDefaults`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IMetadataFactory`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IMField`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IMGroup`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IMGroupBuilder<T,TB>`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IMIntegerString`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IMIntegerStringBuilder`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IMNode`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IMNodeBuilder<T,TB>`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IMNodeMultiplicity`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IMRecord`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IMRecordBuilder`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IMRecordBuilderFactory`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IMString`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IMStringAbstractBuilder<T,TB>`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IMStringBuilder`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IRecordContentBuilderFactory`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IRecordContentReader`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IRecordContentReaderFactory`
* `PushTechnology.ClientInterface.Client.Content.Metadata.IRecordStructuredBuilder`
* `PushTechnology.ClientInterface.Client.Content.Metadata.MDataType`
* `PushTechnology.ClientInterface.Client.Content.Metadata.MetadataContext`
* `PushTechnology.ClientInterface.Client.Content.Metadata.MetadataDefaults`
* `PushTechnology.ClientInterface.Client.Content.Metadata.MetadataNodeType`
* `PushTechnology.ClientInterface.Client.Content.Metadata.MetadataViolationException`
* `PushTechnology.ClientInterface.Client.Content.Metadata.MFieldType`
* `PushTechnology.ClientInterface.Client.Content.Metadata.MNodeDataType`
* `PushTechnology.ClientInterface.Client.Content.Metadata.Multiplicity`
* `PushTechnology.ClientInterface.Client.Content.Metadata.MultiplicityNone`
* `PushTechnology.ClientInterface.Client.Content.Metadata.MultiplicitySingle`
* `PushTechnology.ClientInterface.Client.Content.Metadata.MultiplicityUnbounded`
* `PushTechnology.ClientInterface.Client.Content.Xml.MetadataDataType`
* `PushTechnology.ClientInterface.Client.Content.Xml.MetadataField`
* `PushTechnology.ClientInterface.Client.Content.Xml.MetadataMessage`
* `PushTechnology.ClientInterface.Client.Content.Xml.MetadataNode`
* `PushTechnology.ClientInterface.Client.Content.Xml.MetadataRecord`
* `PushTechnology.ClientInterface.Client.Content.Xml.MetadataTopicDataType`
* `PushTechnology.ClientInterface.Client.Content.IRecord`
* `PushTechnology.ClientInterface.Client.Content.IRecordBuilder`
* `PushTechnology.ClientInterface.Client.Content.IRecordContentBuilder`
* `PushTechnology.ClientInterface.Client.Content.IRecordFactory`
* `PushTechnology.ClientInterface.Client.Factories.Diffusion.Metadata{get}->IMetadataFactory`
* `PushTechnology.ClientInterface.Client.Features.IMessaging.GetStreamsForTopic(string)->ISet<IMessageStream>`
* `PushTechnology.ClientInterface.Client.Features.Control.Topics.IServiceRequest`
* `PushTechnology.ClientInterface.Client.Session.ISession.GetTopicsFeature()->ITopics`
* `PushTechnology.ClientInterface.Client.Session.ISession.GetPingFeature()->IPings`
* `PushTechnology.ClientInterface.Client.Session.ISession.GetTopicControlFeature()->ITopicControl`
* `PushTechnology.ClientInterface.Client.Session.ISession.GetSubscriptionControlFeature()->ISubscriptionControl`
* `PushTechnology.ClientInterface.Client.Session.ISession.GetAuthenticationControlFeature()->IAuthenticationControl`
* `PushTechnology.ClientInterface.Client.Session.ISession.GetSystemAuthenticationControlFeature()->ISystemAuthenticationControl`
* `PushTechnology.ClientInterface.Client.Session.ISession.GetSecurityFeature()->ISecurity`
* `PushTechnology.ClientInterface.Client.Session.ISession.GetTopicUpdateControlFeature()->ITopicUpdateControl`
* `PushTechnology.ClientInterface.Client.Session.ISession.GetMessagingFeature()->IMessaging`
* `PushTechnology.ClientInterface.Client.Session.ISession.GetMessagingControlFeature()->IMessagingControl`
* `PushTechnology.ClientInterface.Client.Session.ISession.GetClientControlFeature()->IClientControl`
* `PushTechnology.ClientInterface.Client.Session.ISession.GetSecurityControlFeature()->ISecurityControl`
* `PushTechnology.ClientInterface.Client.Topics.IRecordTopicDetails`
* `PushTechnology.ClientInterface.Client.Topics.IRecordTopicDetailsAttributes`
* `PushTechnology.ClientInterface.Client.Topics.IRecordTopicDetailsBuilder`
* `PushTechnology.ClientInterface.Client.Topics.IRecordTopicDetailsSchema`
* `PushTechnology.ClientInterface.Client.Topics.ISingleValueTopicDetails`
* `PushTechnology.ClientInterface.Client.Topics.ISingleValueTopicDetailsBuilder`
* `PushTechnology.ClientInterface.Client.Topics.ISingleValueTopicDetailsSchema`
* `PushTechnology.ClientInterface.Client.Topics.ISingleValueTopicDetailsAttributes`
* `PushTechnology.ClientInterface.Client.Topics.TopicType.SINGLE_VALUE`
* `PushTechnology.ClientInterface.Client.Topics.TopicType.RECORD`
* `PushTechnology.ClientInterface.Client.Types.Constants`
* `PushTechnology.ClientInterface.Client.Types.ITopicSendOptions.HeadersList{get}->ReadOnlyCollection<string>`
* `PushTechnology.ClientInterface.Client.Types.ITopicSendOptionsBuilder.SetHeaders(List<string>)->ITopicSendOptionsBuilder`
* `PushTechnology.DiffusionCore.Buffering.BufferUnderflowException`
* `PushTechnology.DiffusionCore.Buffering.BufferOverflowException`
* `PushTechnology.DiffusionCore.Buffering.ByteBuffer`
* `PushTechnology.DiffusionCore.Exceptions.DiffusionAPIException`
* `PushTechnology.DiffusionCore.Exceptions.DiffusionBaseException`
* `PushTechnology.DiffusionCore.Exceptions.DiffusionConnectionException`
* `PushTechnology.DiffusionCore.Exceptions.DiffusionException`
* `PushTechnology.DiffusionCore.Exceptions.DiffusionFatalException`
* `PushTechnology.DiffusionCore.Exceptions.DiffusionMessageException`
* `PushTechnology.DiffusionCore.Exceptions.DiffusionPropertyException`
* `PushTechnology.ClientInterface.Client.Callbacks.ErrorReason.FromValue(int)->ErrorReason`
* `PushTechnology.ClientInterface.Client.Callbacks.DefaultStreamCallback`
* `PushTechnology.ClientInterface.Client.Callbacks.StreamDefault`
* `PushTechnology.ClientInterface.Client.Features.IPingDetails.RoundTripTime{get}->double`

Known Issues:

* None

Notes:

While we tried to get as many new features as possible into this release, our focus was clean-up. We tried to get rid of as much old and unused code as possible and I think the massive list of removed types speaks for itself. There is still a lot more we can and will do in future releases but this is a start. I am particularly proud of our own JSON parser in this release, as well as the new async APIs. Expect more features to receive the same treatment as `ITopics`, `ITopicControl`, and `IPings` did.

We also include our first beta version of the .NET Standard 2.0 compatible library in this release. The plan is to phase out the current .NET Framework library in favor of the .NET Standard compatible library. This allows you to use our client library under .NET Framework, Mono, Xamarin, UWP, and .NET Core.
-DD

## Previous Versions

For versions before 6.0.0, please check the release note history at <https://docs.pushtechnology.com/docs/history_diffusion5.html>.
